/*!
  \file   apriori/GeneralSupportCounterInterface.hpp
  \brief  Interface for a general support counters of Apriori

  \author Ferenc BODON
  \date   2005-05-04
*/
#ifndef GeneralSupportCounterInterface_HPP
#define GeneralSupportCounterInterface_HPP

#include "common.hpp"
#include "common/log.h"
#include <vector>
//#include <cstdio>
//#include <iterator>	//for test



/**
   Interface for a general support counters of Apriori
 */
template <class DATA_STRUCTURE, class TR, class SC = Dummy>
class GeneralSupportCounterInterface
{
   private:

      DATA_STRUCTURE& data_structure;
      TR& transaction_reader;
      SC support_counter;

   public:
      GeneralSupportCounterInterface( DATA_STRUCTURE& data_structure,
				      TR& transaction_reader) :
	 data_structure(data_structure), 
	 transaction_reader(transaction_reader){}

      /**
	 This class determines the support of the candidates.

	 The candidates are stores in data_structure; the transactions
	 can be fetched by transaction_reader (it has to implement 
	 interface TransactionReader). It is possible to provide an additional
	 class, which is in general a special support counter.
	 \param candidate_size the size of the candidates
       */
      void countSupport(const unsigned int candidate_size)
      {
	 log_err(0,"Using countSupport method of SupportCounterInterface"); 
      }

};

#endif
