/*!
  \file   apriori/bodon/Leaf.hpp
  \brief  Leaf of the tries that stores the minimum data, i.e. a counter.

  \author Ferenc BODON
  \date   2005-05-04
*/
#ifndef Leaf_HPP
#define Leaf_HPP

#include "common.hpp"
#include "apriori/bodon/LeafWithoutConstructor.hpp"


namespace Bodon
{
   /** Leaf of the tries that stores the minimum data, i.e. a counter.
    */
   class Leaf : public LeafWithoutConstructor
   {
      public:
	 Leaf() {counter = 0;}
	 Leaf(const counter_t counter) { this->counter = counter;}
   };
}
#endif
