/*!
  \file   apriori/bodon/LeafWithoutConstructor.hpp
  \brief  Leaf of the tries that but constructor is not added to the class.

  \author Ferenc BODON
  \date   2005-05-04
*/
#ifndef LeafWithoutConstructor_HPP
#define LeafWithoutConstructor_HPP

#include "common.hpp"
#include <vector>
//#include <iterator>	//for test


namespace Bodon
{
   /** Leaf of the tries that but constructor is not added to the
    * class. The purpose of this is to use a special block allocator
    */
   class LeafWithoutConstructor
   {
      protected:
	 counter_t counter;
      public:
	 
	 void setCounter(const counter_t counter)
	 {this->counter = counter;}
	 
	 void increaseCounter(const counter_t counter_incr = 1)
	 {this->counter += counter_incr;}
	 
	 counter_t getCounter() const
	 {return counter;}
   };
}
#endif
