/*!  
  \file DecoderBase.hpp
  \brief This is an interface of decoder classes, 

  A decoder is responsible to decode the items in an item sequence and
  write out the decoded sequence.  A decoder is an output manager
  extended by \c setCodeInverse function 

  \author Ferenc BODON 
  \date  2005-04-29
*/

#ifndef DecoderBase_HPP
#define DecoderBase_HPP

  
#include "common.hpp"
#include <vector>
#include <iostream>


template <class O>
class DecoderBase : public O
{
   public:
      typedef typename O::params_t params_t;

      DecoderBase(const params_t* par):O(par){}
      /** This sets the invers of codes.
       
      \param code_inverse the inverse of the codes.
      Assume that the new code of item \e i is denoted by \e code[i].
      Then \a code_inverse[code[i]-1]=i if \e i is a frequent item.
      */
      void setCodeInverse(const std::vector<item_t>& code_inverse)
      {	 
	 std::cerr<<"Error: using function setCodeInverse"<<std::endl;
      }	 
};


#endif
